#include "stdio.h"
#include "stdlib.h"

int GetRandArray(int);
void FillTable();

#define NO_ERRORS 0;
#define ILLEGAL_ARRAY_LENGTH 1

int RandVal[100];
int error = NO_ERRORS;
char Table[5][5];

int main()
{
	char line[81];
	printf("Type the number of random values\n");
	gets_s(line);
	int n = atoi(line);
	int max = GetRandArray(n);
	if (error == ILLEGAL_ARRAY_LENGTH)
	{
		printf("Illegal number of random values\n");
	}
	else
	{
		printf("Random numbers:\n");
		for (int i = 0; i < n; i++)
		{
			printf("%d\n", RandVal[i]);
		}
		printf("Max: %d\n", max);
	}

	FillTable();
	for (int i = 0; i < 5; i++)
	{
		for (int j = 0; j < 5; j++)
		{
			printf("%c", Table[i][j]);
		}
		printf("\n");
	}
	return 0;
}

int GetRandArray(int n)
{
	if (n <= 0 || n > 100)
	{
		error = ILLEGAL_ARRAY_LENGTH;
		return 0;
	}
	int max = 0;
	for (int i = 0; i < n; i++)
	{
		RandVal[i] = rand();
		if (RandVal[i] > max)
		{
			max = RandVal[i];
		}
	}
	return max;
}

void FillTable()
{
	for (int i = 0; i < 5; i++)
	{
		for (int j = 0; j < 5; j++)
		{
			if (i == j)
			{
				Table[i][j] = '*';
			}
			else if (i < j)
			{
				Table[i][j] = '+';
			}
			else
			{
				Table[i][j] = '-';
			}
		}
	}
}

