#include "stdio.h"
#include "stdlib.h"

char* Reverse(char*);
char* CreateRandomString(int);

char *Reverse(char *pInput)
{
	if (!pInput || !*pInput)
		return 0;
	int n = 0;
	for (; *(pInput + n); n++); // find the number of characters in input text
	char *pOutput = (char *)malloc(n + 1);
	for (int i = 0, j = n - 1; i < n; i++, j--)
		*(pOutput + i) = *(pInput + j);
	*(pOutput + n) = 0;
	return pOutput;
}

char *CreateRandomString(int n)
{
	const char alphabet[] = "abcdefghijklmnopqrstuvwxyz";
	char *pResult = (char *)malloc(n + 1);
	for (int i = 0; i < n; i++)
	{
		*(pResult + i) = alphabet[rand() % 26];
	}
	*(pResult + n) = 0;
	return pResult;
}

int main()
{
	for (int i = 0; i < 5; i++)
	{
		char *pIn = CreateRandomString(i);
		if (pIn)
			printf("%s\n", pIn);
		char *pOut = Reverse(pIn);
		if (pOut)
		{
			printf("%s\n", pOut);
			free(pOut);
		}
		if (pIn)
			free(pIn);
	}
	return 0;
}