#include "string.h"
#include "stdio.h"
#include "stdlib.h"
#include "stdarg.h"

char *CreateRandomSentence(int nWords, int n1, ...);
char **SentenceSplit_1(char *pInput, int *pnWords);
int WordExist(char **ppTable, int nTable, char *pWord);

char *CreateRandomSentence(int nWords, int n1, ...)
{ // this code is out of scope of this course. 
   // #include "stdarg.h" is needed
   // nWords is the number of words, it is followed by sequence specifying the word lengths
   // nWords may be any positive number
  va_list indic;
  va_start(indic, nWords);
  int nChars = 0, j = 0;
  for (int i = 0; i < nWords; i++, nChars += va_arg(indic, int) + 1);
  const char alphabet[] = "abcdefghijklmnopqrstuvwxyz";
  char *pResult = (char *)malloc(nChars);
  va_start(indic, nWords);
  for (int i = 0; i < nWords; i++)
  {
        int nWord = va_arg(indic, int);
        for (int k = 0; k < nWord; k++, *(pResult + j++) = alphabet[rand() % 26]);
        *(pResult + j++) = ' ';
  }
  *(pResult + nChars - 1) = 0;
  return pResult;
}

char **SentenceSplit_1(char *pInput, int *pnWords)
{
	if (!pInput || !*pInput)
		return 0;
	int nInput = strlen(pInput);
	int nSpace = 0;
	for (char *p = pInput; 1; )
	{
		char *q = strchr(p, ' ');
		if (!q)
			break;
		else
		{
			nSpace++; // count the number of spaces
			*q = 0; // replace space with zero
			p = q + 1;
		}
	}
	*pnWords = nSpace + 1;
	char **ppOutput = (char **)malloc(*pnWords * sizeof(char *));
	for (int i = 0, iWordBegin = 0;  i < *pnWords;  i++)
	{
		int nWord = strlen(pInput + iWordBegin); // length of word
		*(ppOutput + i) = (char *)malloc(nWord + 1); // memory for word in table
		strcpy(*(ppOutput + i), pInput + iWordBegin); // sopy the word into table
		*(pInput + iWordBegin + nWord) = ' '; // write the space back into input data
		iWordBegin += nWord + 1; // position of the first character of the next word
	}
	*(pInput + nInput) = 0;
	return ppOutput;
}

int WordExist(char **ppTable, int nTable, char *pWord)
{
	if (!ppTable || nTable <= 0 || !pWord || !*pWord)
		return -1;
	for (int i = 0;  i < nTable;  i++)
	{
		if (!strcmp(*(ppTable + i), pWord))
			return 1;
	}
	return 0;
}

int main()
{
	char Sentence[] = "Al Capone was the boss in Chicago";
	int nWords;
	char **ppSplit = SentenceSplit_1(Sentence, &nWords);
	printf("%d\n", WordExist(ppSplit, nWords, (char *)"Al"));
	printf("%d\n", WordExist(ppSplit, nWords, (char *)"Chicago"));
	printf("%d\n", WordExist(ppSplit, nWords, (char *)"boss"));
	printf("%d\n", WordExist(ppSplit, nWords, (char *)"John"));
	return 0;
}