#include "string.h"
#include "stdio.h"
#include "stdlib.h"

char *WordReplace(char *pInput, char *pOldWord, char *pNewWord);

char *WordReplace(char *pInput, char *pOldWord, char *pNewWord)
{
	if (!pInput || !pNewWord || !pOldWord || !*pInput || !*pNewWord || !*pOldWord)
		return 0;
	char *pOldWordBegin = 0;
	int lOldWord = strlen(pOldWord);
	for (char *p = pInput; 1; )
	{ // find the word to replace
		char *q = strstr(p, pOldWord);
		if (!q)
			return 0;
		else if ((q == pInput || *(q - 1) == ' ') && (*(q + lOldWord) == 0 || *(q + lOldWord) == ' '))
		{
			pOldWordBegin = q;
			break;
		}
		else
			p = q + 1;
	}
	int nOutput = strlen(pInput) + strlen(pNewWord) - strlen(pOldWord);
	char *pOutput = (char *)malloc(nOutput + 1);
	strncpy(pOutput, pInput, pOldWordBegin - pInput); // section before the word to repace
	*(pOutput + (pOldWordBegin - pInput)) = 0;
	strcat(pOutput, pNewWord);
	strcat(pOutput, pOldWordBegin + lOldWord);// section after the word to replace
	return pOutput;
}

int main()
{
	printf("%s\n", WordReplace((char *)"I asked Mary to call me", (char *)"Mary", (char *)"Elizabeth"));
	printf("%s\n", WordReplace((char *)"Mary asked me to call Tom", (char *)"Mary", (char *)"Elizabeth"));
	printf("%s\n", WordReplace((char *)"Tom asked me to call Mary", (char *)"Mary", (char *)"Elizabeth"));
	printf("%s\n", WordReplace((char *)"I asked Elizabeth to call me", (char *)"Elizabeth", (char *)"Mary"));
	printf("%s\n", WordReplace((char *)"Elizabeth asked me to call Tom", (char *)"Elizabeth", (char *)"Mary"));
	printf("%s\n", WordReplace((char *)"Tom asked me to call Elizabeth", (char *)"Elizabeth", (char *)"Mary"));
	printf("%s\n", WordReplace((char *)"and band android and candy and", (char *)"and", (char *)"band"));
	printf("%s\n", WordReplace((char *)"band and android", (char *)"and", (char *)"band"));
	printf("%s\n", WordReplace((char *)"android candy and band", (char *)"and", (char *)"band"));
	printf("%s\n", WordReplace((char *)"candy and candy", (char *)"and", (char *)"band"));
	return 0;
}