#include "stdio.h"
#include "malloc.h"
#include "string.h"
#pragma warning (disable: 4996) 

typedef struct Date
{
	int day;
	char month[4];
	int year;
} DATE;

typedef struct Exam
{
	char* pSubject;
	DATE date;
	int mark;
} EXAM;

EXAM** MySession_v1(int* pnExams)
{
	const char* Subjects[] =
	{
		"Mathematics", "Physics", "Chemistry"
	};
	DATE dates[] =
	{
		{ 3, "Jan", 2019},
		{ 13, "Jan", 2019 },
		{ 20, "Jan", 2019 }
	};
	int marks[] = { 5, 4, 3 };

	*pnExams = 3;

	EXAM** ppMyExams = (EXAM **)malloc(3 * sizeof(EXAM*));
	for (int i = 0; i < 3; i++)
	{
		*(ppMyExams + i) = (EXAM *)malloc(sizeof(EXAM));
		(*(ppMyExams + i))->pSubject = (char*)malloc(strlen(Subjects[i]) + 1);
		strcpy((*(ppMyExams + i))->pSubject, Subjects[i]);
		(*(ppMyExams + i))->date = dates[i];
		(*(ppMyExams + i))->mark = marks[i];
	}
	return ppMyExams;
}

EXAM** MySession_v2(int* pnExams)
{
	const char* Subjects[] =
	{
		"Mathematics", "Physics", "Chemistry"
	};
	DATE dates[] =
	{
		{ 3, "Jan", 2019},
		{ 13, "Jan", 2019 },
		{ 20, "Jan", 2019 }
	};
	int marks[] = { 5, 4, 3 };

	*pnExams = 3;

	EXAM** ppMyExams = (EXAM**)malloc(3 * sizeof(EXAM*));
	for (int i = 0; i < 3; i++)
	{
		EXAM* p;
		*(ppMyExams + i) = p = (EXAM*)malloc(sizeof(EXAM));
		p->pSubject = (char*)malloc(strlen(Subjects[i]) + 1);
		strcpy(p->pSubject, Subjects[i]);
		p->date = dates[i];
		p->mark = marks[i];
	}
	return ppMyExams;
}

EXAM** MySession_v3(int* pnExams)
{
	const char* Subjects[] =
	{
		"Mathematics", "Physics", "Chemistry"
	};
	DATE dates[] =
	{
		{ 3, "Jan", 2019},
		{ 13, "Jan", 2019 },
		{ 20, "Jan", 2019 }
	};
	int marks[] = { 5, 4, 3 };

	*pnExams = 3;

	EXAM** ppMyExams = (EXAM**)malloc(3 * sizeof(EXAM*));
	for (int i = 0; i < 3; i++)
	{
		ppMyExams[i] = (EXAM*)malloc(sizeof(EXAM));
		ppMyExams[i]->pSubject = (char*)malloc(strlen(Subjects[i]) + 1);
		strcpy(ppMyExams[i]->pSubject, Subjects[i]);
		ppMyExams[i]->date = dates[i];
		ppMyExams[i]->mark = marks[i];
	}
	return ppMyExams;
}

int main()
{
	int nExams;
	EXAM** ppMyExams = MySession_v3(&nExams);

	printf("My examinations:\n");
	for (int i = 0; i < nExams; i++)
	{
		printf("%s at %d-%s-%d, mark is %d\n", (*(ppMyExams + i))->pSubject, (*(ppMyExams + i))->date.day,
			(*(ppMyExams + i))->date.month, (*(ppMyExams + i))->date.year, (*(ppMyExams + i))->mark);
	}
	double average = 0;
	for (int i = 0; i < nExams; i++)
	{
		average += (*(ppMyExams + i))->mark;
	}
	average /= 3;
	printf("The average mark was %2lg\n", average);
	for (int i = 0; i < 3; i++)
	{
		free((*(ppMyExams + i))->pSubject);
		free(*(ppMyExams + i));
	}
	free(ppMyExams);
	return 0;
}