#include "stdio.h"
#include "math.h"

int MaxOfThree(int, int, int);
double TempConverter(double, char);

int main()
{
	printf("%d\n", MaxOfThree(1, 2, 3));
	printf("%d\n", MaxOfThree(3, 2, 1));
	printf("%d\n", MaxOfThree(1, 3, 2));
	printf("%d\n", MaxOfThree(1, 1, 3));
	printf("%d\n", MaxOfThree(3, 1, 1));
	printf("%d\n", MaxOfThree(1, 3, 1));
	printf("%d\n", MaxOfThree(3, 3, 3));
	
	char test[] = { 'c', 'C', 'f', 'F', 'x' };
	int i = 0;
	while (i < 5)
	{
		double t = TempConverter(100, test[i]);
		if (isnan(t))
		{
			printf("No solution\n");
		}
		else
		{
			printf("Result is %.1f\n", t);
		}
		i = i + 1;
	}
	return 0;
}

int MaxOfThree(int a, int b, int c)
{
	if (a >= b && a >= c)
	{
		return a;
	}
	if (b >= a && b >= c)
	{
		return b;
	}
	return c;
}

double TempConverter(double temp, char type)
{
	if (type == 'f' || type == 'F')
	{
		return (temp - 32) * 5 / 9;
	}
	if (type == 'c' || type == 'C')
	{
		return temp * 9 / 5 + 32;
	}
	return NAN;
}