#include "string.h"
#include "stdio.h"

int WordSearch(char *pInput, char *pWord)
{
	if (!pInput || !pWord || !*pInput || !*pWord)
		return 0;
	int nWord = 0, lWord = strlen(pWord);
	for (char *p = pInput; 1; )
	{
		char *q = strstr(p, pWord);
		if (!q)
			break;
		else if ((q == pInput || *(q - 1) == ' ') && (*(q + lWord) == 0 || *(q + lWord) == ' '))
		{ // there is a space before the word and a space after the word
          // exceptions: no space before the first word, no space after the last word
			nWord++;
			p = strchr(q, ' ');
			if (!p)
				break;
		}
		p++;
	}
	return nWord;
}

int main()
{
	printf("%d\n", WordSearch((char *)"Jesse James famous outlaw", (char *)"famous"));
	printf("%d\n", WordSearch((char *)"Jesse James famous outlaw", (char *)"Jesse"));
	printf("%d\n", WordSearch((char *)"Jesse James famous outlaw", (char *)"outlaw"));
	printf("%d\n", WordSearch((char *)"Jesse James famous outlaw", (char *)"John"));
	printf("%d\n", WordSearch((char *)"Jesse Jesse Jesse", (char *)"Jesse"));
	printf("%d\n", WordSearch((char *)"and band android and candy and", (char *)"and"));
	printf("%d\n", WordSearch((char *)"band and android", (char *)"and"));
	printf("%d\n", WordSearch((char *)"android candy and band", (char *)"and"));
	printf("%d\n", WordSearch((char *)"candy and candy", (char *)"and"));
	return 0;
}