#include "stdio.h"
#include "malloc.h"
#include "string.h"
#pragma warning (disable: 4996) 

typedef struct Date
{
	int day;
	char month[4];
	int year;
} DATE;

typedef struct Exam
{
	char *pSubject;
	DATE date;
	int mark;
} EXAM;

EXAM *MySession(int *pnExams)
{
	const char* Subjects[] =
	{
		"Mathematics", "Physics", "Chemistry"
	};
	DATE dates[] =
	{
		{ 3, "Jan", 2019},
		{ 13, "Jan", 2019 },
		{ 20, "Jan", 2019 }
	};
	int marks[] = { 5, 4, 3 };

	*pnExams = 3; 

	EXAM *pExams = (EXAM *)malloc(3 * sizeof(EXAM));

	for (int i = 0; i < 3; i++)
	{
		(pExams+i)->pSubject = (char *)malloc(strlen(Subjects[i]) + 1);
		strcpy((pExams+i)->pSubject, Subjects[i]);
		(pExams + i)->date = dates[i];
		(pExams + i)->mark = marks[i];
	}
	return pExams;
}

int main()
{
	int nExams;
	EXAM* pMyExams = MySession(&nExams);

	printf("My examinations:\n");
	for (int i = 0; i < nExams; i++)
	{
		printf("%s at %d-%s-%d, mark is %d\n", (pMyExams + i)->pSubject, (pMyExams + i)->date.day, 
			   (pMyExams + i)->date.month, (pMyExams + i)->date.year, (pMyExams + i)->mark);
	}
	double average = 0;
	for (int i = 0; i < nExams; i++)
	{
		average += (pMyExams + i)->mark;
	}
	average /= 3;
	printf("The average mark was %2lg\n", average);
	for (int i = 0; i < 3; i++)
	{
		free((pMyExams + i)->pSubject);
	}
	free(pMyExams);
	return 0;
}